• Codeforces Round #417 C. Sagheer and Nubian Market


    time limit per test  2 seconds
    memory limit per test  256 megabytes
     

    On his trip to Luxor and Aswan, Sagheer went to a Nubian market to buy some souvenirs for his friends and relatives. The market has some strange rules. It contains n different items numbered from 1 to n. The i-th item has base cost ai Egyptian pounds. If Sagheer buysk items with indices x1, x2, ..., xk, then the cost of item xj is axj + xj·k for 1 ≤ j ≤ k. In other words, the cost of an item is equal to its base cost in addition to its index multiplied by the factor k.

    Sagheer wants to buy as many souvenirs as possible without paying more than S Egyptian pounds. Note that he cannot buy a souvenir more than once. If there are many ways to maximize the number of souvenirs, he will choose the way that will minimize the total cost. Can you help him with this task?

    Input

    The first line contains two integers n and S (1 ≤ n ≤ 105 and 1 ≤ S ≤ 109) — the number of souvenirs in the market and Sagheer's budget.

    The second line contains n space-separated integers a1, a2, ..., an (1 ≤ ai ≤ 105) — the base costs of the souvenirs.

    Output

    On a single line, print two integers kT — the maximum number of souvenirs Sagheer can buy and the minimum total cost to buy these ksouvenirs.

     
    input
    3 11
    2 3 5
    output
    2 11
    input
    4 100
    1 2 5 6
    output
    4 54
    input
    1 7
    7
    output
    0 0
    Note
    In the first example, he cannot take the three items because they will cost him [5, 9, 14] with total cost 28. If he decides to take only two items, then the costs will be [4, 7, 11]. So he can afford the first and second items.
    
    In the second example, he can buy all items as they will cost him [5, 10, 17, 22].
    
    In the third example, there is only one souvenir in the market which will cost him 8 pounds, so he cannot buy it.
    Note


    题目大意:
         在一个商店里一共有n件商品,每一件都有一个基础价格,但是这个商店有一个奇怪的规定,
         每一件商品最后的价格为 基础价格+买的商品总件数*商品的坐标(即这是第几件商品)
         现给定 商品的件数和你所拥有的钱数, 问你最多能卖几件商品 花的总钱数是多少

    解题思路:
         总体思路为:二分查找 先找出最多能买的商品的件数,然后在计算出总花费

    AC代码:
     1 #include <iostream>
     2 #include <algorithm>
     3 using namespace std;
     4 typedef long long ll;
     5 
     6 int main ()
     7 {
     8     ll n,s,sum,x,y,l,r;
     9     ll ans[100010],a[100010];
    10     int i;
    11     cin>>n>>s;
    12         for (i = 1; i <= n; i ++)
    13             cin>>a[i];
    14         
    15         l = 1,r = n;  // 左标签和右标签 
    16         x = y = 0;
    17         while (l <= r){
    18             sum = 0;
    19             ll mid = (r+l)>>1;   // 二分枚举能购买的商品件数 
    20             for (i = 1; i <= n; i ++)
    21                 ans[i] = a[i]+i*mid;
    22             sort(ans+1,ans+1+n);   
    23             for (i = 1; i <= mid; i ++)
    24                 sum += ans[i];
    25             if (sum <= s){
    26                 x = mid;
    27                 y = sum;
    28                 l = mid+1;
    29             }
    30             else
    31                 r = mid-1;
    32         }
    33         cout<<x<<" "<<y<<endl;
    34     return 0;
    35 } 
    以下版本思路同上;
    #include <stdio.h>
    #include <string.h>
    #include <algorithm>
    using namespace std;
    
    int main ()
    {
        __int64 n,s;
        __int64 ans[100010],a[100010];
        int i;
        while (~scanf("%I64d%I64d",&n,&s))
        {
            for (i = 1; i <= n; i ++)
                scanf("%I64d",&a[i]);
            
            int l = 1,r = n;
            __int64 sum,x=0,y=0;
            while (l <= r){
                sum = 0;
                long long mid = (l+r)>>1;
                for (i = 1; i <= n; i ++)
                    ans[i] = a[i]+i*mid;
                sort(ans+1,ans+1+n);
                for (i = 1; i <= mid; i ++)
                    sum += ans[i];
                if (sum > s)
                    r = mid-1;
                else
                    l = mid+1;
            }
            for (i = 1; i <= n; i ++)
                    ans[i] = a[i]+i*r;
                sort(ans+1,ans+1+n);
                for (i = 1; i <= r; i ++)
                    y += ans[i];
            printf("%d %I64d
    ",r,y);
        }
        return 0;
    } 
    
    
    
     
  • 相关阅读:
    《JavaScript高级程序设计》阅读笔记(十七):事件
    Windows 8 Consumer Preview版升级到 Release Preview 版后Metro应用(html5+JavaScript版)修改小结
    [转]linux netstat命令查看端口是否占用
    jQuery 1.8 Release版本发布了
    分享一个用原生JavaScript写的带缓动效果的图片幻灯
    [转]Javascript 绝句
    win8 下 WCF "Could not load type 'System.ServiceModel.Activation.HttpModule'" 错误解决方案
    【转】WEB APP 不同设备屏幕下图片适应分辨率
    给你的JS类库加上命名空间和扩展方法:jutil第一次重构
    Javascript图像处理之将彩色图转换成灰度图
  • 原文地址:https://www.cnblogs.com/yoke/p/6995237.html
Copyright © 2020-2023  润新知